#include <arm_common_tables.h>
#include "FastLED.h"
#include "RingBuffer.h"

// How many leds in your strip?
#define NUM_LEDS 193
#define RING_60 0
#define RING_40 60
#define RING_32 100
#define RING_24 132
#define RING_16 156
#define RING_12 172
#define RING_8 184
#define RING_1 192

int rings[] = {60,40,32,24,16,12,8,1};
int offsets[] = {0,60,100,132,156,172,184,192};

// For led chips like Neopixels, which have a data line, ground, and power, you just
// need to define DATA_PIN.  For led chipsets that are SPI based (four wires - data, clock,
// ground, and power), like the LPD8806, define both DATA_PIN and CLOCK_PIN
#define DATA_PIN 5

// Define the array of leds
CRGB leds[NUM_LEDS];


void setup() {
  // put your setup code here, to run once:
  LEDS.addLeds<WS2812,DATA_PIN,GRB>(leds,NUM_LEDS-1);
  //LEDS.addLeds<WS2812, 14,RGB>(leds,NUM_LEDS-1, 1);
  LEDS.setBrightness(14);
  FastLED.setMaxPowerInVoltsAndMilliamps(5,1500);
}

int offset=0;
int j;


void loop() {
 
  
  //set_ring_color(CRGB::Red,3);
 //set_ring_color(CRGB::Green,2);
 
  effect1();
  effect1();
  effect1();
  //fadealldelay();
  //delay(100);
  circle(CRGB::Blue,CRGB::DarkGreen);
  fadealldelay();
  delay(100);
  effect2();
  effect2();
  fadealldelay();
  delay(100);
  for(int i = 0;  i < 25; i++) 
  effect3();
  fadealldelay();
  delay(100);
  for(int i = 0;  i < 25; i++) 
  green_and_stars();
 fadealldelay();
  delay(100);
}

void effect1()
{
  static uint8_t hue = 0;
  for(int i = 0;  i < NUM_LEDS; i++) 
  {
    leds[i] = CHSV(hue++, 255, 255);
    FastLED.show();
    fadeall();
    delay(10);
  } 
  for(int i = 0;  i < 100; i++) 
  {
    fadeall();
    FastLED.show();
    // Wait a little bit before we loop around and do it again
    delay(10);
    
  }
 }

 void effect2()
{
   static uint8_t hue = 0;
 
  for(int i = 0;  i < 255; i++) 
  {
    set_tree_color(CHSV(hue++, 255, 255));
    FastLED.show();
     delay(20);
  }
}

void effect3()
{
  CRGB a=CHSV(random(0,255),255,255);
    CRGB b=CHSV(random(0,255),255,105);
    int k=0;
  for (int j = 0;  j < 8; j++) 
  {
    k+=5;
    for(int i = 0;  i < 8; i++) 
    {
      if (i==j)
       set_ring_color(a, i);
      else
       set_ring_color(b, i);
    }
    delay(80-k);
  }
  
}


void green_and_stars()
{  
   uint8_t buf_len = 20;
   uint8_t buffer[buf_len];
   uint8_t buf_cnt = 0;

   
   for(int i = 0;  i < buf_len; i++) {buffer[i]=255;}

   for(int i = 0;  i < NUM_LEDS-1; i++) 
   {
    leds[i]=CRGB::Green;
   }
    uint8_t temp,hue;
   
   
  
      temp+=5;
      leds[192] = CHSV(temp,255,255);

      for(int i = 0;  i < 190; i++) 
      {
       if(i%5==0){
          leds[i] = CHSV(hue,255,255); 
         
       }       
      }
      hue+=4;
      
      for(int i = 0;  i < buf_len; i++) 
      {
       buffer[i] = random(0,NUM_LEDS-1);   
       leds[buffer[i]] = CRGB::White; 
      }
       FastLED.show();
       
         for(int j=0;j<10;j++)
         {
           for(int i=0;i<buf_len;i++)
           {
            
              leds[buffer[i]].nscale8(180);
            
           }
           FastLED.show();
           delay(75);
         }
         for(int i = 0;  i < buf_len; i++) 
      {
         leds[buffer[i]] = CRGB::Green; 
         leds[buffer[i]].maximizeBrightness();
      
      }
  }

void circle(CRGB color1,CRGB color2)
{
   leds[192]=CRGB::White;
   
   for(int k=0;k<300;k++)
  {
   j=offset; 
  for (int i=0;i<59;i++)
  {
    if (i<30)
    {
     
    leds[j]=color1;
    leds[RING_40+(int)(double(j)*4.0/6.0)]=color1;
    leds[RING_32+(int)(double(j)*3.2/6.0)]=color1;
    leds[RING_24+(int)(double(j)*2.4/6.0)]=color1;
    leds[RING_16+(int)(double(j)*1.6/6.0)]=color1;
    leds[RING_12+(int)(double(j)*1.2/6.0)]=color1;
    leds[RING_8+(int)(double(j)*0.8/6.0)]=color1;
    
    }
    else
    {
      
      leds[j]=color2;
      leds[RING_40+(int)(double(j)*4.0/6.0)]=color2;
    leds[RING_32+(int)(double(j)*3.2/6.0)]=color2;
    leds[RING_24+(int)(double(j)*2.4/6.0)]=color2;
    leds[RING_16+(int)(double(j)*1.6/6.0)]=color2;
    leds[RING_12+(int)(double(j)*1.2/6.0)]=color2;
    leds[RING_8+(int)(double(j)*0.8/6.0)]=color2;
      }
      j+=1;
  if (j==60)
    j=0;
  }

  offset=(offset+1)%60;
  delay(22);
  FastLED.show();
}
  }

void set_ring_color(CRGB color , int ring)
{
  if ((ring>=0)&&(ring<8))
  { 
     for(int i = offsets[ring]; i < offsets[ring]+rings[ring]; i++) 
     {
      leds[i]=color;
      }

     FastLED.show();
  }
 }

 void set_tree_color(CRGB color)
{
    for(int i = 0;  i < NUM_LEDS; i++) 
  {
    leds[i]=color;
   }
} 


 

void fadeall() { for(int i = 0; i < NUM_LEDS; i++) { leds[i].nscale8(250); } }

void fadeall_by(uint8_t val) { for(int i = 0; i < NUM_LEDS; i++) { leds[i].nscale8(val); } }

void fadealldelay() { 
  for(int k=0;k<30;k++){
    for(int i = 0; i < NUM_LEDS; i++) { 
      leds[i].nscale8(180); 
      } delay(25);
      FastLED.show();
      }}


